unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Math, ComCtrls, Menus;

type
  TForm1 = class(TForm)
    Button1: TButton;
    PaintBox1: TPaintBox;
    Label1: TLabel;
    StatusBar1: TStatusBar;
    GroupBox1: TGroupBox;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    Edit5: TEdit;
    Edit6: TEdit;
    GroupBox2: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    Bevel1: TBevel;
    Bevel2: TBevel;
    ProgressBar1: TProgressBar;
    MainMenu1: TMainMenu;
    Help2: TMenuItem;
    About2: TMenuItem;
    HowtoUseHelp2: TMenuItem;
    SearchforHelpOn2: TMenuItem;
    Contents2: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses About;

{$R *.dfm}


procedure TForm1.Button1Click(Sender: TObject);
var
 a, b, x, y, n: integer;
 Vp, Ve, Vd, Vs, Vi, V1, V2, V3, V4: double;

 begin
if (edit1.text <> '') and (edit2.text <> '') and (edit3.text <> '') and (edit4.text <> '') and (edit5.text <> '') and (edit6.text <> '') then
 begin
  a := strtoint(edit5.text);
  b := strtoint(edit6.text);
  V1 := strtofloat(edit1.text);
  V2 := strtofloat(edit2.text);
  V3 := strtofloat(edit3.text);
  V4 := strtofloat(edit4.text);

  Ve := 0;
  Vd := 0;
  Vs := 0;
  Vi := 0;

  for x := 1 to a do
   begin
    for y := 1 to b do
     begin
      for n := 1 to 50 do
       Begin
        Ve := Ve + (((2*V2)/(n*Pi))*((1 - (cos(n*Pi)))/(Sinh((n*Pi*a)/b)))*(Sinh((n*Pi*X)/b))*(sin((n*Pi*Y)/b)));
        Vd := Vd + (((2*V4)/(n*Pi))*(1 - (cos(n*Pi)))*(-1*(cosh((n*Pi*a)/b))/(Sinh((n*Pi*a)/b)))*((Sinh((n*Pi*X)/b))-(((sinh((n*Pi*a)/b))/(cosh((n*Pi*a)/b)))*(cosh((n*Pi*X)/b))))*(sin((n*Pi*Y)/b)));
        Vs := Vs + (((2*V1)/(n*Pi))*(1 - (cos(n*Pi)))*(-1*(cosh((n*Pi*b)/a))/(Sinh((n*Pi*b)/a)))*((Sinh((n*Pi*Y)/a))-(((sinh((n*Pi*b)/a))/(cosh((n*Pi*b)/a)))*(cosh((n*Pi*Y)/a))))*(sin((n*Pi*X)/a)));
        Vi := Vi + (((2*V3)/(n*Pi))*((1 - (cos(n*Pi)))/(Sinh((n*Pi*b)/a)))*(Sinh((n*Pi*Y)/a))*(sin((n*Pi*X)/a)));
       end;

      Vp := Ve + Vd + Vs + Vi;
      Ve := 0;
      Vd := 0;
      Vs := 0;
      Vi := 0;

      if (Vp > 0) and (Vp < 10) then
       paintbox1.Canvas.Pixels[x,y] := clgreen
      else if (Vp >= 10) and (Vp < 20) then
       paintbox1.Canvas.Pixels[x,y] := clred
      else if (Vp >= 10) and (Vp < 20) then
       paintbox1.Canvas.Pixels[x,y] := clblue
      else if (Vp >= 20) and (Vp < 30) then
       paintbox1.Canvas.Pixels[x,y] := clAqua
      else if (Vp >= 30) and (Vp < 40) then
       paintbox1.Canvas.Pixels[x,y] := clblack
      else if (Vp >= 40) and (Vp < 50) then
       paintbox1.Canvas.Pixels[x,y] := clGray
      else if (Vp >= 50) and (Vp < 60) then
       paintbox1.Canvas.Pixels[x,y] := clOlive
      else if (Vp >= 60) and (Vp < 70) then
       paintbox1.Canvas.Pixels[x,y] := clMaroon
       else if (Vp >= 70) and (Vp < 80) then
       paintbox1.Canvas.Pixels[x,y] := clFuchsia
       else if (Vp >= 80) and (Vp < 90) then
       paintbox1.Canvas.Pixels[x,y] := clTeal
       else if (Vp >= 90) and (Vp < 100) then
       paintbox1.Canvas.Pixels[x,y] := clYellow
      else
       paintbox1.Canvas.Pixels[x,y] := clwhite;

    end;
  end;
 end
else
 showmessage('Valores imcompletos');
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
 a, b, n: integer;
 Ve, Vd, Vs, Vi, V1, V2, V3, V4: double;

begin

a := strtoint(edit5.text);
b := strtoint(edit6.text);
V1 := strtofloat(edit1.text);
V2 := strtofloat(edit2.text);
V3 := strtofloat(edit3.text);
V4 := strtofloat(edit4.text);

Ve := 0;
Vd := 0;
Vs := 0;
Vi := 0;

for n := 1 to 50 do
 Begin
  Ve := Ve + (((2*V2)/(n*Pi))*((1 - (cos(n*Pi)))/(Sinh((n*Pi*a)/b)))*(Sinh((n*Pi*X)/b))*(sin((n*Pi*Y)/b)));
  Vd := Vd + (((2*V4)/(n*Pi))*(1 - (cos(n*Pi)))*(-1*(cosh((n*Pi*a)/b))/(Sinh((n*Pi*a)/b)))*((Sinh((n*Pi*X)/b))-(((sinh((n*Pi*a)/b))/(cosh((n*Pi*a)/b)))*(cosh((n*Pi*X)/b))))*(sin((n*Pi*Y)/b)));
  Vs := Vs + (((2*V1)/(n*Pi))*(1 - (cos(n*Pi)))*(-1*(cosh((n*Pi*b)/a))/(Sinh((n*Pi*b)/a)))*((Sinh((n*Pi*Y)/a))-(((sinh((n*Pi*b)/a))/(cosh((n*Pi*b)/a)))*(cosh((n*Pi*Y)/a))))*(sin((n*Pi*X)/a)));
  Vi := Vi + (((2*V3)/(n*Pi))*((1 - (cos(n*Pi)))/(Sinh((n*Pi*b)/a)))*(Sinh((n*Pi*Y)/a))*(sin((n*Pi*X)/a)));
 end;

 button1.Caption := floattostr(Ve + Vd + Vs + Vi);


end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
if not (key in ['0','1','2','3','4','5','6','7','8','9', #32]) then
 Key := #0;
end;

end.
